
/* lua-utils.c
 * 
 * Copyright (C) 2009 Francesco Abbate
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or (at
 * your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 */

#include <lua.h>
#include <lauxlib.h>
#include <string.h>
#include "lua-utils.h"

struct mod_callback const *
mod_callback_find (struct mod_callback const *ls, char const *name)
{
  for (/* */; ls->name; ls++)
    {
      if (strcmp (ls->name, name) == 0)
	break;
    }

  if (ls->name == NULL)
    return NULL;

  return ls;
}

int
mod_callback_exec (lua_State *L, struct mod_callback const *ls, char const *key)
{
  struct mod_callback const * cb;
  cb = mod_callback_find (ls, key);
  if (cb)
    {
      if (cb->cfunc)
	{
	  lua_pushcfunction (L, cb->cfunc);
	  return 1;
	}
      return cb->ifunc (L);
    }
  return 0;
}
