
/* lua-utils.h
 * 
 * Copyright (C) 2009 Francesco Abbate
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or (at
 * your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 */

#ifndef LUA_UTILS_H
#define LUA_UTILS_H

#include <lua.h>

struct mod_callback {
  char const * name;
  lua_CFunction cfunc; /* a function to return */
  lua_CFunction ifunc; /* a function to call immediately */
}; 

extern int
mod_callback_exec (lua_State *L, struct mod_callback const *ls,
		   char const *key);

extern struct mod_callback const *
mod_callback_find (struct mod_callback const *ls, char const *name);

#endif
